#include <stdio.h>

/* romchuf 0.0 */
/* an attempt at parsing the new-style (version 2?) romc */

int main(int argc, char **argv)
{
    FILE *infile = fopen(argv[1], "rb");
    unsigned char buf[4];

    fread(buf, 4, 1, infile);
    int segcount = 0;

    while (1==fread(buf, 4, 1, infile))
    {
        long size;

        size = buf[3];
        size *= 0x100;
        size |= buf[2];
        size *= 0x100;
        size |= buf[1];
        size *= 0x10;
        size |= buf[0]>>4;

        if ((buf[0]&0xF) > 2)
        {
            size ++;
        }

        /* segment is uncompressed? */
        if ((buf[0]&0xF) == 0)
        {
            size = 0x10004;
        }

        printf("%08lx=%08lx: %02x%02x%02x%02x %08lx\n",
            (unsigned long)(ftell(infile)-4),
            (unsigned long)segcount*0x10000UL,
            (unsigned int)buf[0], (unsigned int)buf[1],
            (unsigned int)buf[2], (unsigned int)buf[3],
            (unsigned long)size);

        segcount ++;

        fseek(infile, size-4, SEEK_CUR);
    }
}
